<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace App\RestApi\ServiceOrder\Controllers;



use Freelabois\LaravelQuickstart\Traits\Crudable;
use Illuminate\Http\Request;
use Schaffen\Core\Form\Managers\FormAssociationManager;
use Schaffen\Core\Form\Managers\FormManager;
use Schaffen\Core\Form\Repositories\FormRepository;

class ServiceOrderFormController
{

    use Crudable;
    /**
     * @var FormAssociationManager
     */
    private $association_manager;

    public function __construct(
        FormManager $manager,
        FormRepository $repository,
        FormAssociationManager $association_manager
    )
    {
        $this->setup($manager, $repository);
        $this->association_manager = $association_manager;
    }

    public function index(Request $request, $id = null)
    {

        $array_filters = array_merge([
            'foa_formeavel_codigo' => $id,
            'foa_formeavel_tipo' => 'service-order',
        ], $request->all());
        return $this->repository->list($array_filters);
    }

    public function update(Request $request, $service_order, $form = null)
    {
        $sanitized_input = $request->all();
        $awnsered_form = $this->association_manager->answerFormFromEntity($sanitized_input, $service_order, $form);
        return response()->json($awnsered_form->form);
    }


}
