<?php

namespace App\Services\Login\Controllers;

use App\Domain\Utils\Controllers\PassportController;
use App\Domain\Utils\Requests\LoginRequest;
use Schaffen\Login\Login\Managers\UserManager;


class LoginController
{

    protected UserManager $user_manager;

    public function __construct(
        UserManager $user_manager
    )
    {
        $this->user_manager = $user_manager;
    }

    public function login(LoginRequest $request)
    {

        $sanitized = $request->all();
        $results = $this->user_manager->login($sanitized['username'], $sanitized['password']);

        if (count($results) == 0) {
            return response(["success" => false, "message" => "Usuário não encontrado"]);
        }

        if (count($results) == 1) {
            $login_controller = app()->make(PassportController::class);
            $result = $results->pop();

            return array_merge(["EmpBanco" => $result['EmpBanco']], json_decode($login_controller->getPassportToken(
                $result['usu_nome'],
                $sanitized['password'],
                $result['EmpBanco'])
                ->getContents(), true));

        }
        if (count($results) > 1) {
            $login_controller = app()->make(PassportController::class);
            $response = [];

            foreach ($results as $result) {

                $passport = $login_controller->getPassportToken($result['usu_nome'], $sanitized['password'], $result['EmpBanco']);
                $response[] = array_merge(["EmpBanco" => $result['EmpBanco']],
                    json_decode($passport->getContents(), true));


            }

            return $response;

        }


    }


}
